/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { PageEmailValidationRequest, ValidateEmailAddressListOptions, ValidateEmailAddressListResult } from '../models';
export interface DeleteValidationRequestRequest {
    id: string;
}
export interface GetValidationRequestsRequest {
    page?: number;
    size?: number;
    sort?: GetValidationRequestsSortEnum;
    searchFilter?: string;
    since?: Date;
    before?: Date;
    isValid?: boolean;
}
export interface ValidateEmailAddressListRequest {
    validateEmailAddressListOptions: ValidateEmailAddressListOptions;
}
/**
 *
 */
export declare class EmailVerificationControllerApi extends runtime.BaseAPI {
    /**
     * Delete all validation requests
     */
    deleteAllValidationRequestsRaw(initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     * Delete all validation requests
     */
    deleteAllValidationRequests(initOverrides?: RequestInit): Promise<void>;
    /**
     * Delete a validation record
     */
    deleteValidationRequestRaw(requestParameters: DeleteValidationRequestRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     * Delete a validation record
     */
    deleteValidationRequest(requestParameters: DeleteValidationRequestRequest, initOverrides?: RequestInit): Promise<void>;
    /**
     * Validate a list of email addresses. Per unit billing. See your plan for pricing.
     */
    getValidationRequestsRaw(requestParameters: GetValidationRequestsRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<PageEmailValidationRequest>>;
    /**
     * Validate a list of email addresses. Per unit billing. See your plan for pricing.
     */
    getValidationRequests(requestParameters: GetValidationRequestsRequest, initOverrides?: RequestInit): Promise<PageEmailValidationRequest>;
    /**
     * Validate a list of email addresses. Per unit billing. See your plan for pricing.
     */
    validateEmailAddressListRaw(requestParameters: ValidateEmailAddressListRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<ValidateEmailAddressListResult>>;
    /**
     * Validate a list of email addresses. Per unit billing. See your plan for pricing.
     */
    validateEmailAddressList(requestParameters: ValidateEmailAddressListRequest, initOverrides?: RequestInit): Promise<ValidateEmailAddressListResult>;
}
/**
 * @export
 * @enum {string}
 */
export declare enum GetValidationRequestsSortEnum {
    ASC = "ASC",
    DESC = "DESC"
}
