/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 * Options for creating an inbox replier. Repliers can be attached to inboxes and send automated responses when an inbound email matches given criteria.
 * @export
 * @interface CreateInboxReplierOptions
 */
export interface CreateInboxReplierOptions {
    /**
     * Inbox ID to attach replier to
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    inboxId: string;
    /**
     * Name for replier
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    name?: string | null;
    /**
     * Field to match against to trigger inbox replier for inbound email
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    field: CreateInboxReplierOptionsFieldEnum;
    /**
     * String or wildcard style match for field specified when evaluating reply rules. Use `*` to match anything.
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    match: string;
    /**
     * Reply-to email address when sending replying
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    replyTo?: string | null;
    /**
     * Subject override when replying to email
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    subject?: string | null;
    /**
     * Send email from address
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    from?: string | null;
    /**
     * Email reply charset
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    charset?: string | null;
    /**
     * Ignore sender replyTo when responding. Send directly to the sender if enabled.
     * @type {boolean}
     * @memberof CreateInboxReplierOptions
     */
    ignoreReplyTo?: boolean | null;
    /**
     * Send HTML email
     * @type {boolean}
     * @memberof CreateInboxReplierOptions
     */
    isHTML?: boolean | null;
    /**
     * Email body for reply
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    body?: string | null;
    /**
     * ID of template to use when sending a reply
     * @type {string}
     * @memberof CreateInboxReplierOptions
     */
    templateId?: string | null;
    /**
     * Template variable values
     * @type {{ [key: string]: object; }}
     * @memberof CreateInboxReplierOptions
     */
    templateVariables?: {
        [key: string]: object;
    } | null;
}
/**
 * @export
 * @enum {string}
 */
export declare enum CreateInboxReplierOptionsFieldEnum {
    RECIPIENTS = "RECIPIENTS",
    SENDER = "SENDER",
    SUBJECT = "SUBJECT",
    ATTACHMENTS = "ATTACHMENTS"
}
export declare function CreateInboxReplierOptionsFromJSON(json: any): CreateInboxReplierOptions;
export declare function CreateInboxReplierOptionsFromJSONTyped(json: any, ignoreDiscriminator: boolean): CreateInboxReplierOptions;
export declare function CreateInboxReplierOptionsToJSON(value?: CreateInboxReplierOptions | null): any;
