/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface GenerateDmarcRecordOptions
 */
export interface GenerateDmarcRecordOptions {
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    domain: string;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    version: GenerateDmarcRecordOptionsVersionEnum;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    policy: GenerateDmarcRecordOptionsPolicyEnum;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    subdomainPolicy?: GenerateDmarcRecordOptionsSubdomainPolicyEnum;
    /**
     *
     * @type {Array<string>}
     * @memberof GenerateDmarcRecordOptions
     */
    reportEmailAddress?: Array<string>;
    /**
     *
     * @type {Array<string>}
     * @memberof GenerateDmarcRecordOptions
     */
    forensicEmailAddress?: Array<string>;
    /**
     *
     * @type {number}
     * @memberof GenerateDmarcRecordOptions
     */
    percentage?: number;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    reportFormat?: GenerateDmarcRecordOptionsReportFormatEnum;
    /**
     *
     * @type {number}
     * @memberof GenerateDmarcRecordOptions
     */
    secondsBetweenReports?: number;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    adkim?: GenerateDmarcRecordOptionsAdkimEnum;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    aspf?: GenerateDmarcRecordOptionsAspfEnum;
    /**
     *
     * @type {string}
     * @memberof GenerateDmarcRecordOptions
     */
    fo?: GenerateDmarcRecordOptionsFoEnum;
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsVersionEnum {
    DMARC1 = "DMARC1"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsPolicyEnum {
    NONE = "NONE",
    QUARANTINE = "QUARANTINE",
    REJECT = "REJECT"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsSubdomainPolicyEnum {
    NONE = "NONE",
    QUARANTINE = "QUARANTINE",
    REJECT = "REJECT"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsReportFormatEnum {
    AFRF = "AFRF"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsAdkimEnum {
    STRICT = "STRICT",
    RELAXED = "RELAXED"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsAspfEnum {
    STRICT = "STRICT",
    RELAXED = "RELAXED"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GenerateDmarcRecordOptionsFoEnum {
    _0 = "FO_0",
    _1 = "FO_1",
    D = "FO_D",
    S = "FO_S"
}
export declare function GenerateDmarcRecordOptionsFromJSON(json: any): GenerateDmarcRecordOptions;
export declare function GenerateDmarcRecordOptionsFromJSONTyped(json: any, ignoreDiscriminator: boolean): GenerateDmarcRecordOptions;
export declare function GenerateDmarcRecordOptionsToJSON(value?: GenerateDmarcRecordOptions | null): any;
