/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 * Inbox replier. Will automatically reply to inbound emails that match given field for an inbox.
 * @export
 * @interface InboxReplierDto
 */
export interface InboxReplierDto {
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    id: string;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    inboxId: string;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    name?: string | null;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    field: InboxReplierDtoFieldEnum;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    match: string;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    replyTo?: string | null;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    subject?: string | null;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    from?: string | null;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    charset?: string | null;
    /**
     *
     * @type {boolean}
     * @memberof InboxReplierDto
     */
    isHTML: boolean;
    /**
     *
     * @type {string}
     * @memberof InboxReplierDto
     */
    templateId?: string | null;
    /**
     *
     * @type {{ [key: string]: object; }}
     * @memberof InboxReplierDto
     */
    templateVariables?: {
        [key: string]: object;
    } | null;
    /**
     *
     * @type {boolean}
     * @memberof InboxReplierDto
     */
    ignoreReplyTo: boolean;
    /**
     *
     * @type {Date}
     * @memberof InboxReplierDto
     */
    createdAt: Date;
}
/**
 * @export
 * @enum {string}
 */
export declare enum InboxReplierDtoFieldEnum {
    RECIPIENTS = "RECIPIENTS",
    SENDER = "SENDER",
    SUBJECT = "SUBJECT",
    ATTACHMENTS = "ATTACHMENTS"
}
export declare function InboxReplierDtoFromJSON(json: any): InboxReplierDto;
export declare function InboxReplierDtoFromJSONTyped(json: any, ignoreDiscriminator: boolean): InboxReplierDto;
export declare function InboxReplierDtoToJSON(value?: InboxReplierDto | null): any;
