/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 * Sent email details
 * @export
 * @interface SentEmailDto
 */
export interface SentEmailDto {
    /**
     * ID of sent email
     * @type {string}
     * @memberof SentEmailDto
     */
    id: string;
    /**
     * User ID
     * @type {string}
     * @memberof SentEmailDto
     */
    userId: string;
    /**
     * Inbox ID email was sent from
     * @type {string}
     * @memberof SentEmailDto
     */
    inboxId: string;
    /**
     * Domain ID
     * @type {string}
     * @memberof SentEmailDto
     */
    domainId?: string | null;
    /**
     * Recipients email was sent to
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    to?: Array<string> | null;
    /**
     * Sent from address
     * @type {string}
     * @memberof SentEmailDto
     */
    from?: string | null;
    /**
     *
     * @type {string}
     * @memberof SentEmailDto
     */
    replyTo?: string | null;
    /**
     *
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    cc?: Array<string> | null;
    /**
     *
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    bcc?: Array<string> | null;
    /**
     * Array of IDs of attachments that were sent with this email
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    attachments?: Array<string> | null;
    /**
     *
     * @type {string}
     * @memberof SentEmailDto
     */
    subject?: string | null;
    /**
     * MD5 Hash
     * @type {string}
     * @memberof SentEmailDto
     */
    bodyMD5Hash?: string | null;
    /**
     * Sent email body
     * @type {string}
     * @memberof SentEmailDto
     */
    body?: string | null;
    /**
     *
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    toContacts?: Array<string> | null;
    /**
     *
     * @type {string}
     * @memberof SentEmailDto
     */
    toGroup?: string | null;
    /**
     *
     * @type {string}
     * @memberof SentEmailDto
     */
    charset?: string | null;
    /**
     *
     * @type {boolean}
     * @memberof SentEmailDto
     */
    isHTML?: boolean | null;
    /**
     *
     * @type {Date}
     * @memberof SentEmailDto
     */
    sentAt: Date;
    /**
     *
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    pixelIds?: Array<string> | null;
    /**
     *
     * @type {string}
     * @memberof SentEmailDto
     */
    messageId?: string | null;
    /**
     *
     * @type {Array<string>}
     * @memberof SentEmailDto
     */
    messageIds?: Array<string> | null;
    /**
     *
     * @type {boolean}
     * @memberof SentEmailDto
     */
    virtualSend?: boolean | null;
    /**
     *
     * @type {string}
     * @memberof SentEmailDto
     */
    templateId?: string | null;
    /**
     *
     * @type {{ [key: string]: object; }}
     * @memberof SentEmailDto
     */
    templateVariables?: {
        [key: string]: object;
    } | null;
    /**
     *
     * @type {{ [key: string]: string; }}
     * @memberof SentEmailDto
     */
    headers?: {
        [key: string]: string;
    } | null;
    /**
     *
     * @type {boolean}
     * @memberof SentEmailDto
     */
    html?: boolean;
}
export declare function SentEmailDtoFromJSON(json: any): SentEmailDto;
export declare function SentEmailDtoFromJSONTyped(json: any, ignoreDiscriminator: boolean): SentEmailDto;
export declare function SentEmailDtoToJSON(value?: SentEmailDto | null): any;
