/* tslint:disable */
/* eslint-disable */
/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * A compact representation of a full email. Used in list endpoints to keep response sizes low. Body and attachments are not included. To get all fields of the email use the `getEmail` method with the email projection's ID. See `EmailDto` for documentation on projection properties.
 * @export
 * @interface EmailProjection
 */
export interface EmailProjection {
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  subject?: string | null;
  /**
   *
   * @type {Array<string>}
   * @memberof EmailProjection
   */
  attachments?: Array<string> | null;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  inboxId: string;
  /**
   *
   * @type {Array<string>}
   * @memberof EmailProjection
   */
  to: Array<string>;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  domainId?: string | null;
  /**
   *
   * @type {Array<string>}
   * @memberof EmailProjection
   */
  bcc?: Array<string> | null;
  /**
   *
   * @type {Array<string>}
   * @memberof EmailProjection
   */
  cc?: Array<string> | null;
  /**
   *
   * @type {boolean}
   * @memberof EmailProjection
   */
  read: boolean;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  bodyExcerpt?: string | null;
  /**
   *
   * @type {boolean}
   * @memberof EmailProjection
   */
  teamAccess: boolean;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  bodyMD5Hash?: string | null;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  textExcerpt?: string | null;
  /**
   *
   * @type {Date}
   * @memberof EmailProjection
   */
  createdAt: Date;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  id: string;
  /**
   *
   * @type {string}
   * @memberof EmailProjection
   */
  from?: string | null;
}

export function EmailProjectionFromJSON(json: any): EmailProjection {
  return EmailProjectionFromJSONTyped(json, false);
}

export function EmailProjectionFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): EmailProjection {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    subject: !exists(json, 'subject') ? undefined : json['subject'],
    attachments: !exists(json, 'attachments') ? undefined : json['attachments'],
    inboxId: json['inboxId'],
    to: json['to'],
    domainId: !exists(json, 'domainId') ? undefined : json['domainId'],
    bcc: !exists(json, 'bcc') ? undefined : json['bcc'],
    cc: !exists(json, 'cc') ? undefined : json['cc'],
    read: json['read'],
    bodyExcerpt: !exists(json, 'bodyExcerpt') ? undefined : json['bodyExcerpt'],
    teamAccess: json['teamAccess'],
    bodyMD5Hash: !exists(json, 'bodyMD5Hash') ? undefined : json['bodyMD5Hash'],
    textExcerpt: !exists(json, 'textExcerpt') ? undefined : json['textExcerpt'],
    createdAt: new Date(json['createdAt']),
    id: json['id'],
    from: !exists(json, 'from') ? undefined : json['from'],
  };
}

export function EmailProjectionToJSON(value?: EmailProjection | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    subject: value.subject,
    attachments: value.attachments,
    inboxId: value.inboxId,
    to: value.to,
    domainId: value.domainId,
    bcc: value.bcc,
    cc: value.cc,
    read: value.read,
    bodyExcerpt: value.bodyExcerpt,
    teamAccess: value.teamAccess,
    bodyMD5Hash: value.bodyMD5Hash,
    textExcerpt: value.textExcerpt,
    createdAt: value.createdAt.toISOString(),
    id: value.id,
    from: value.from,
  };
}
